var syncTaskConfig = { 
		name: "syncTaskConfig", 
		deleteBoxTitle: "",
		deleteBoxMessage: "",
		statusChangeTitle: "",
		statusChangeSuccess: "",
		statusChangeFail: "",
		syncManualTitle: "",
		syncManualSuccess: "",
		syncManualFail: ""
};

syncTaskConfig.editConfigCallBack = function(data, tableId) {
    var response = jQuery.parseJSON(data);
    if(response.messageType == OrionAction.STATUS_ERROR) {
    	OrionAction.addStatusMessage(response.message, response.messageType);
    } else {
    	OrionAction.clearStatus();
    	syncTaskConfig.editConfig(response.message);
    }
}

syncTaskConfig.editConfig = function (uid) {
    OrionCore.showPleaseWait(true);
    var params = { UID: uid };
	
    function onSuccess(response) {
    	if (response.exception) {
            OrionCore.showPleaseWait(false);
            OrionCore.setDialogBoxTitle(syncTaskConfig.dataCollectionFailEditTitle);
            OrionCore.showDialogBox(true, response.message, OrionCore.DIALOG_OK, 200, 300);    		
    	} else {
    		OrionCore.doAction('/saasc/ldapSyncConfig.do', ['UIDs', uid ], 'post');
    	}
    }

    function onError(jqxhr, settings, exception) {
        OrionCore.showPleaseWait(false);
    	sessionExpired();
    };

    $j.ajax({
        type: "POST",
        url: "/saasc/checkCustomerSyncType.do",
        data: params,
        dataType: "json",
        success: onSuccess,
        error: onError
    });
};

/**
 * Session is expired, redirect user to home
 */
sessionExpired = function () {
	OrionCore.doAction('/saasc/taskListHome.do', null);
}

syncTaskConfig.viewConfigCallBack = function (data, tableId) {
    var response = jQuery.parseJSON(data);
    if (response.messageType == OrionAction.STATUS_ERROR) {
    	OrionAction.addStatusMessage(response.message, response.messageType);
    } else {
    	OrionAction.clearStatus();
    	syncTaskConfig.viewConfig(response.message);
    }
}

syncTaskConfig.viewConfig = function (uid) {
    OrionCore.showPleaseWait(true);
    var params = { UID: uid };
	
    function onSuccess(response) {
    	if (response.exception) {
            OrionCore.showPleaseWait(false);
            OrionCore.setDialogBoxTitle(syncTaskConfig.dataCollectionFailEditTitle);
            OrionCore.showDialogBox(true, response.message, OrionCore.DIALOG_OK, 200, 300 );    		
    	} else {
    		OrionCore.doAction('/saasc/ldapSyncConfig.do', ['UIDs', uid, 'view', 'true'], 'post');
    	}
    }

    function onError(jqxhr, settings, exception) {
        OrionCore.showPleaseWait(false);
    	sessionExpired();
    };

    $j.ajax({
        type: "POST",
        url: "/saasc/checkCustomerSyncType.do",
        data: params,
        dataType: "json",
        success: onSuccess,
        error: onError
    });
};

var globalTaskId = "";
syncTaskConfig.deleteConfig = function(taskId) {
	globalTaskId = taskId;
	OrionCore.dialogBoxOkHandler = syncTaskConfig.deleteConfigOkHandler;
	OrionCore.dialogBoxCancelHandler = null;
	OrionCore.setDialogBoxTitle(OrionCore.escapeHtml(syncTaskConfig.deleteBoxTitle));
	OrionCore.showDialogBox( true, OrionCore.escapeHtml(syncTaskConfig.deleteBoxMessage), OrionCore.DIALOG_OK_CANCEL );
};

syncTaskConfig.toggleSyncTaskStatusCallBack = function(data, tableId) {
    var response = jQuery.parseJSON(data);
    if (response.messageType == OrionAction.STATUS_ERROR) {
    	OrionAction.addStatusMessage(response.message, response.messageType);
    } else {
    	OrionAction.clearStatus();
        syncTaskConfig.toggleSyncTaskStatus(response.message);
    }
};

syncTaskConfig.toggleSyncTaskStatus = function (uid) {
	var table = MFSTable.get('serverTaskListTable');
	var colStatus = table.getColumn(uid, "schedulingEnabled");
	var colStatusSpan = YAHOO.util.Selector.query('span', colStatus, true);

    OrionCore.showPleaseWait(true);
    var params = { UID: uid };
	
    function onSuccess(response) {
        OrionCore.showPleaseWait(false);
    	if (response.exception) {
            OrionCore.setDialogBoxTitle(syncTaskConfig.statusChangeTitle);
        	OrionCore.showDialogBox(true, syncTaskConfig.statusChangeFail + ": " + response.message, OrionCore.DIALOG_OK, 200, 350 );    		
    	} else {
    		if (response.isTaskSetup) {
    			$j(uid + "_link").text(response.message);
            	colStatusSpan.innerHTML = response.message;
            	var colInterval = table.getColumn(uid, "schedulingInterval");
    			var colIntervalSpan = YAHOO.util.Selector.query('span', colInterval, true);
    			var colNextRun = table.getColumn(uid, "nextRunTime");
    			var colNextRunSpan = YAHOO.util.Selector.query('span', colNextRun, true);
    			colNextRunSpan.innerHTML = response.nextRuntime;
            	if (response.enabled) {
            		colIntervalSpan.style.color = '#CCC';
    				colNextRunSpan.style.color = '#CCC';
            	} else {
    				colIntervalSpan.style.color = '#A0A0A0';
    				colNextRunSpan.style.color = '#A0A0A0';
            	}
            	
                OrionCore.showPleaseWait(false);
                OrionCore.setDialogBoxTitle(syncTaskConfig.statusChangeTitle);        	
            	OrionCore.showDialogBox(true, syncTaskConfig.statusChangeSuccess, OrionCore.DIALOG_OK, 200, 350 );
                
            	table.reload();    			
    		} else {
            	OrionCore.dialogBoxOkHandler = function () {
            	    OrionCore.showPleaseWait(true);
            		OrionCore.doAction('/saasc/ldapSyncConfig.do', ['UIDs', uid ], 'post');
            		return true;
            	}
            	
            	OrionCore.dialogBoxCancelHandler = function () {
            		return true;
            	}

            	OrionCore.setDialogBoxTitle(syncTaskConfig.reviewSettingsTitle);
            	OrionCore.showDialogBox(true, response.message, OrionCore.DIALOG_OK_CANCEL, 200, 300);    			
    		}
    	}
    }
    
    function onError(jqxhr, settings, exception) {
        OrionCore.showPleaseWait(false);
    	sessionExpired();
    };

    $j.ajax({
    	type: "POST",
        url: "/saasc/changeSyncTaskStatus.do",
        data: params,
        dataType: "json",
        success: onSuccess,
        error: onError
    });
};
	
syncTaskConfig.deleteConfigOkHandler = function () {
    OrionCore.doAction('/saasc/performDeleteLink.do', ['UIDs', globalTaskId ]);
    globalTaskId = "";
};

syncTaskConfig.executeManualSyncCallBack = function(data, tableId) {
    var response = jQuery.parseJSON(data);
    if (response.messageType == OrionAction.STATUS_ERROR) {
    	OrionAction.addStatusMessage(response.message, response.messageType);
    } else {
    	OrionAction.clearStatus();
        syncTaskConfig.executeManualSync(response.message);
    }
};

syncTaskConfig.executeManualSync = function (uid) {
    OrionCore.showPleaseWait(true);
	var params = { UID: uid };
	
	function onSuccess(response) {
        OrionCore.showPleaseWait(false);
        
        if (response.isTaskSetup || response.exception) {
        	OrionCore.setDialogBoxTitle(syncTaskConfig.syncManualTitle);         
        	OrionCore.showDialogBox(true, response.message, OrionCore.DIALOG_OK, 200, 300);

        	MFSTable.get("serverTaskListTable").refresh();
        } else {
        	OrionCore.dialogBoxOkHandler = function () {
        	    OrionCore.showPleaseWait(true);
        		OrionCore.doAction('/saasc/ldapSyncConfig.do', ['UIDs', uid ], 'post');
        		return true;
        	}
        	
        	OrionCore.dialogBoxCancelHandler = function () {
        		return true;
        	}

        	OrionCore.setDialogBoxTitle(syncTaskConfig.reviewSettingsTitle);
        	OrionCore.showDialogBox(true, response.message, OrionCore.DIALOG_OK_CANCEL, 200, 300);
        }        
    }
	
    function onError(jqxhr, settings, exception) {
        OrionCore.showPleaseWait(false);
    	sessionExpired();
    };

    $j.ajax({
    	type: "POST",
        url: "/saasc/executeManualSync.do",
        data: params,
        dataType: "json",
        success: onSuccess,
        error: onError
    });

};

syncTaskConfig.reviewSync = function (uid) {
	OrionCore.showPleaseWait(true);
    var params = { UID: uid };
	
    function onSuccess(response) {
    	if (response.exception) {
            OrionCore.showPleaseWait(false);
            OrionCore.setDialogBoxTitle(syncTaskConfig.dataCollectionFailReviewTitle);
            OrionCore.showDialogBox(true, response.message, OrionCore.DIALOG_OK, 200, 300 );    		
    	} else {
    		OrionCore.doAction('/saasc/reviewSyncResults.do', ['UID', uid ], 'post');
    	}
    }

    function onError(jqxhr, settings, exception) {
        OrionCore.showPleaseWait(false);
        sessionExpired();
    };

    $j.ajax({
        type: "POST",
        url: "/saasc/checkCustomerSyncType.do",
        data: params,
        dataType: "json",
        success: onSuccess,
        error: onError
    });
};

syncTaskConfig.reviewSyncCallBack = function(data, tableId) {
    var response = jQuery.parseJSON(data);
    if (response.messageType == OrionAction.STATUS_ERROR) {
        OrionAction.addStatusMessage(response.message, response.messageType);
    } else {
    	OrionAction.clearStatus();
    	syncTaskConfig.reviewSync(response.message);
    }
};

syncTaskConfig.checkErrors = function(){
	if(syncTaskConfig.errorAuthorizationListMsg != ''){
		OrionCore.setDialogBoxTitle(syncTaskConfig.errorAuthorizationListTitle);
		var oldCallBack = OrionCore.dialogBoxOkHandler;
		OrionCore.dialogBoxOkHandler =  function() {
			OrionCore.dialogBoxOkHandler = oldCallBack;
			OrionCore.doAction('/rs/showRsIndex.do');
		};
		OrionCore.showDialogBox(true, syncTaskConfig.errorAuthorizationListMsg, OrionCore.DIALOG_OK, 200, 300);
	}
};